---
- name: install apache by apt
  ansible.builtin.apt:
    pkg:
      - apache2
      - libapache2-mpm-itk
    state: present
- name: Cleanup uneeded default files
  ansible.builtin.file:
    path: "{{ item }}"
    state: absent
  loop:
    - /etc/apache2/sites-available/000-default.conf
    - /etc/apache2/sites-available/default-ssl.conf
    - /etc/apache2/sites-enabled/000-default.conf
    - /etc/apache2/ports.conf
  notify: Apache Restart
- name: Upload configuration
  ansible.builtin.template:
    src: "templates/{{ item }}.j2"
    dest: "/etc/apache2/{{ item }}"
    owner: root
    group: root
    mode: "0644"
  loop:
    - apache2.conf
    - conf-available/0-basic.conf
    - sites-available/0-default.conf
    - sites-available/0-default-ssl.conf
  notify: Apache Restart
- name: Turning on and off modules, entities and sites
  ansible.builtin.shell: 'a2{{ item[0] }}{{ item[1] }} {{ item[2] }}'
  register: script_res
  changed_when: '"already {{ item[0] }}abled" not in script_res.stdout'
  failed_when: script_res.rc != 0
  notify: Apache Restart
  loop:
    # we ignore mpms as we do not know yet, what will we finally use
    #- [ "dis", "mod",  "mpm_itk" ]
    #- [ "dis", "mod",  "mpm_prefork" ]
    #- [ "en",  "mod",  "mpm_worker" ]
    - [ "en",  "conf", "0-basic" ]
    - [ "dis", "conf", "charset" ]
    - [ "dis", "conf", "localized-error-pages" ]
    - [ "dis", "conf", "other-vhosts-access-log" ]
    - [ "dis", "conf", "serve-cgi-bin" ]
    - [ "dis", "conf", "security" ]
    - [ "en",  "site", "0-default" ]
    - [ "en",  "site", "0-default-ssl" ]
